package main

import (
	"fmt"

	"merkle-tree/internal/app/hashing"
	"merkle-tree/internal/app/merkle_tree"
)

func main() {
	exampleData := []string{"1", "2", "3", "4", "5", "6", "7", "8", "9"}
	hashTransactions := []string{}
	for i := range exampleData {
		hash := hashing.ToHash(exampleData[i])
		hashTransactions = append(hashTransactions, hash)
	}
	merkleRoot, pathToMerkleRoot := merkle_tree.GenerateRootHash(hashTransactions)
	for _, hashToFind := range hashTransactions {
		authPath := merkle_tree.GenerateMerklePath(hashToFind, pathToMerkleRoot)
		authMerkleRoot := merkle_tree.GenerateFromMerklePath(hashToFind, authPath)
		if authMerkleRoot != merkleRoot {
			panic("Original Merkle root not equal to Merkle root generated by auth path")
		}
	}

	unExistTransactions := []string{"10", "11", "12", "13", "14", "15", "16", "17", "18"}
	hashTransactions = []string{}
	for i := range unExistTransactions {
		hash := hashing.ToHash(unExistTransactions[i])
		hashTransactions = append(hashTransactions, hash)
	}
	for _, hashToFind := range hashTransactions {
		authPath := merkle_tree.GenerateMerklePath(hashToFind, pathToMerkleRoot)
		authMerkleRoot := merkle_tree.GenerateFromMerklePath(hashToFind, authPath)
		if authMerkleRoot == merkleRoot {
			panic("For unexist transaction must not be merkle root!")
		}
	}
	fmt.Println("All works as expected")
}
